function toggleCheckbox(id) {
    document.getElementById(id).checked = !document.getElementById(id).checked;
    user_clicked();
}

function get_cookie(name) {
    var cookie_value = null;
    if (document.cookie && document.cookie != '') {
        var cookies = document.cookie.split(';');
        for (var i = 0; i < cookies.length; i++) {
            var cookie = cookies[i];
            cookie = cookie.trim();
            cookie = cookie.split('=');
            if (cookie[0] == name) {
                cookie_value = decodeURIComponent(cookie[1]);
                break;
            }
        }
    }
    return cookie_value;
}

function get_request() {
    var request = null;
    if (window.XMLHttpRequest) { // Mozilla, Safari, ...
        request = new XMLHttpRequest();
    }
    else if (window.ActiveXObject) { // IE
        try {
            request = new ActiveXObject("Msxml2.XMLHTTP");
        } 
        catch (e) {
            try {
                request = new ActiveXObject("Microsoft.XMLHTTP");
            } 
            catch (e) {}
        }
    }
    return request;
}

function show_comm_prefs() {
    if (this.readyState === 4) {
        if (this.status === 200) {
            var data = JSON.parse(this.responseText);
            // alert(data.email_valid);
            if (data.email_valid == true) {
                if (data.has_newsletter_explicit_consent == false) {
                    document.getElementById('comm-prefs').style.display = 'block';
                    document.getElementById('comm-prefs-newsletter').style.display = 'block';
                    document.getElementById('id_newsletterSub').checked = false;
                }
                else {
                    document.getElementById('comm-prefs-newsletter').style.display = 'none';
                    document.getElementById('id_newsletterSub').checked = true;
                }
                if (document.getElementById('comm-prefs-newsletter').style.display == 'none') {
                    document.getElementById('comm-prefs').style.display = 'none';
                }
            }
        }
    }
}

var clicked_comm_prefs = false;

function has_explicit_consent_handler() {
    var request = get_request();

    if (!request) {
        return false;
    }

    document.getElementById('id_newsletterSub').onclick = function() {
        clicked_comm_prefs=true;
    };

    if (clicked_comm_prefs) {
        return false;
    }

    email = document.getElementById('id_email').value;
    csrftoken = get_cookie('csrftoken');

    request.onreadystatechange = show_comm_prefs;
    request.open('POST', '../../../has-explicit-consent/');
    request.setRequestHeader("X-CSRFToken", csrftoken);
    request.send(email);
}

// Lightbox functions
function lightbox_escape_enable() {
    window.addEventListener(
        'keyup',
        function(event) {
            if (event.key == 'Escape') {
                lightbox_close();
            }
        },
        true
    )
}

function lightbox_open(focus_id=null) {
    lightbox = document.getElementById('lightbox');
    lightbox.style.display = 'block';
    self.setTimeout(
        function(){
            lightbox.style.opacity = 1;
            if (focus_id != null) {
                focus_element = document.getElementById(focus_id);
                focus_element.focus();
            }
        },
        1,
    );
    lightbox_escape_enable();
}

function lightbox_close() {
    lightbox = document.getElementById('lightbox');
    lightbox.style.opacity = 0;
    self.setTimeout(
        function(){lightbox.style.display = 'None';},
        200,
    );
}

// Feedback functions
function feedback_escape_enable() {
    window.addEventListener(
        'keyup',
        function(event) {
            if (event.key == 'Escape') {
                feedback_close();
            }
        },
        true
    );
}

function feedback_open(focus_id=null) {
    feedback = document.getElementById('feedback');
    feedback.style.display = 'block';
    self.setTimeout(
        function(focus_id){
            feedback.style.opacity = 1;
            if (focus_id != null) {
                focus_element = document.getElementById(focus_id);
                focus_element.focus();
            }
        },
        1,
    );
    feedback_escape_enable();
    self.setTimeout(
        function(){
            feedback_close();
        },
        3500
    );
    return true;
}

function feedback_close() {
    feedback = document.getElementById('feedback');
    feedback.style.opacity = 0;
    self.setTimeout(
        function(){
            feedback.style.display = 'None';
        },
        200,
    );
    return true;
}

function update_cart_items_count() {
    element = document.getElementById('cart_items_count');
    span_elements = document.querySelectorAll('.cart-items-count');
    if (!(element || span_elements)) {
        return false;
    }
    var request = get_request();
    if (!request) {
        return false;
    }
    request.onreadystatechange = function() {
        if (this.readyState === 4) {
            if (this.status === 200) {
                var data = JSON.parse(this.responseText);
                var count = data.count;
                if (element) {
                    element.innerHTML = count;
                }
                span_elements.forEach(
                    (span_element) => {
                        span_element.innerHTML = count;
                        // console.log(span_element, count);
                        // nav_element = span_element.parentElement.parentElement.parentElement
                        // if (count > 0) {
                        //     nav_element.style.display = 'block';
                        // }
                        // else {
                        //     nav_element.style.display = 'none';
                        // }
                    }
                )
            }
        }
    };
    request.open('GET', '../../../cart/items-count/');
    request.send();
}
